@echo off
echo Dieses Skript hilft bei der Erstellung der Schluessel fuer das VPN "valeria".
echo.
echo Das Skript erstellt einen privaten Schluessel(userkey.pem) und eine Zertifikat-
echo anfrage(userreq.pem).
echo Mit dem privaten Schluessel wird das VPN verschluesselt und der Benutzer ein-
echo deutig identifiziert. Der private Schluessel ersetzt also das Passwort mit dem
echo man sich in das VPN einlogt. Deshalb darf niemand ausser dir Zugriff auf diese
echo Datei haben.
echo Um ein vollstaendiges Zertifikat(usercert.pem) zu erstellen, muss die Anfrage 
echo noch vom VPN Betreiber signiert werden. Nur Benutzer mit korrekt signiertem
echo Zertifikat haben Zugriff zum VPN.
echo.
pause

echo.
echo Man kann den privaten Schluessel zusaetzlich mit einem Passwort schuetzen.
echo Dann muss, JEDES mal wenn der Schluessel verwendet werden soll, das Passwort
echo eingegeben werden.


:passwortfrage
echo Moechtest du deinen privaten Schluessel durch ein Passwort schuetzen?
SET /P auswahl=Ja[1] / Nein[0]: 
IF %auswahl%==1 GOTO mitpw
IF %auswahl%==0 GOTO ohnepw
GOTO passwortfrage


:mitpw
echo.
echo Gib dein Passwort fuer den Schluessel bei "Enter PEM pass phrase" an. Dein
echo Passwort muss mindestens 4 Zeichen lang sein und wird bei der Eingabe NICHT
echo angezeigt.
echo Bei der Erstellung der Zertifikatanfrage musst du einige Daten angeben.
echo Gibst du bei einer Frage nichts ein wird die Vorgabe in eckigen Klammern ueber-
echo nommen. Gibst du einen "." ein bleibt das Feld leer. Einige Felder muessen aus-
echo gefuellt werden. Optionale Felder koennen leer bleiben.
echo.
pause
bin\openssl.exe req -config bin\openssl.conf -newkey rsa:4096 -keyout userkey.pem -out userreq.pem
GOTO ende


:ohnepw
echo.
echo Bei der Erstellung der Zertifikatanfrage musst du einige Daten angeben.
echo Gibst du bei einer Frage nichts ein wird die Vorgabe in eckigen Klammern ueber-
echo nommen. Gibst du einen "." ein bleibt das Feld leer. Einige Felder muessen aus-
echo gefuellt werden. Optionale Felder koennen leer bleiben.
echo.
pause
bin\openssl.exe req -config bin\openssl.conf -nodes -newkey rsa:4096 -keyout userkey.pem -out userreq.pem
GOTO ende

:ende
echo.
echo.
echo Der private Schluessel(userkey.pem) und die Zertifikatanfrage(userreq.pem) sind
echo jetzt erstellt. Sende die Zertifikatanfrage(userreq.pem) an den VPN Betreiber
echo damit er sie signiert und dir das Zertifikat(usercert.pem) zuruecksendet.
echo.
echo Bitte beachte, dass der private Schluessel(userkey.pem) geheim bleibt. Niemand
echo ausser dir, auch nicht der VPN Betreiber, kennen deinen Schluessel. Wenn du den
echo Schluessel verlierst (oder das Passwort vergisst), kann der Schluessel nicht
echo wiederhergestellt werden und du musst Schluessel und Anfrage komplett neu er-
echo stellen.
echo.
pause
